# LiveQA

[![Build Status](https://travis-ci.org/arkes/liveqa-node.svg?branch=master)](https://travis-ci.org/arkes/liveqa-node)

LiveQA javascript integration for [LiveQA](https://www.liveqa.io)

## Installation

```sh 
npm install liveqa --save
```

## Configuration

```js
// Account token can be found inside your environment settings
LiveQA.accountToken = 'acc_xx'

// The name of your space
LiveQA.spaceName = 'LiveQA'

// The name of your environement
LiveQA.environmentName = 'production'
 
// If enabled is set to false nothing is send to the server
// default: true
// LiveQA.enabled = false
 
// Extra attributes to be obfuscated
// default: []
// LiveQA.obfuscatedFields = ['credit_card_number']

// Metadata is passed with every request to the server
// default: {}
// LiveQA.metadata = {
//   customer: {
//     name: 'John Doe'
//   },
//   version: 42
// }
//
```

## Usage

```js
var LiveQA = require('liveqa');
```

ECMAScript 2015:

```js
import liveQA from 'liveqa';
```

### Track

Track an event

Attributes:

* `String` event name
* `Object` event attributes

```js
LiveQA.track('my event',
  {
    user_id: 42,
    properties: {
        order_id: 84 
    }
  }
);
```

### Identify

Identify a user

Attributes:

* `String` user id from your database
* `Object` user attributes

```js
LiveQA.identify(42,
  {
    properties: {
      name: 'John Doe' 
    }
  }
);
```

### Watch

Create a watcher

Attributes:

* `String|Integer` template flow name or id
* `Object` watcher attributes

```js
LiveQA.watch('My Flow',
  {
    expected_times: 42
  }
);
```

## Issues

If you have any issue you can report them on github, or contact support@liveqa.io
