'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * Libraries
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */


/*
* Resources
*/


/*
* API Resources
*/

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _message = require('./message');

var _message2 = _interopRequireDefault(_message);

var _event = require('./event');

var _event2 = _interopRequireDefault(_event);

var _group = require('./group');

var _group2 = _interopRequireDefault(_group);

var _identity = require('./identity');

var _identity2 = _interopRequireDefault(_identity);

var _watcher = require('./watcher');

var _watcher2 = _interopRequireDefault(_watcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
* Base LiveQA class
*/
var LiveQA = function () {
  function LiveQA() {
    _classCallCheck(this, LiveQA);
  }

  _createClass(LiveQA, null, [{
    key: 'track',


    /*
    * Send track event
    *
    * @param [String] event name
    * @param [Object] payload to be send
    * @param [Object] options for the request
    *
    * @return [Promise] response from the server
    */
    value: function track(name) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!_config2.default.enabled) return true;

      var payloadToSend = (0, _deepmerge2.default)(payload, {
        type: 'track',
        name: name
      });

      return _event2.default.create((0, _deepmerge2.default)(_message2.default.extended, payloadToSend), requestOptions);
    }

    /*
    * Send identify event
    *
    * @param [String] user id from your database
    * @param [Object] payload to be send
    * @param [Object] options for the request
    *
    * @return [Promise] response from the server
    */

  }, {
    key: 'identify',
    value: function identify(userId) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!_config2.default.enabled) return true;

      var payloadToSend = (0, _deepmerge2.default)(payload, {
        type: 'identify',
        userId: userId
      });

      return _event2.default.create((0, _deepmerge2.default)(_message2.default.extended, payloadToSend), requestOptions);
    }

    /*
    * create/update group
    *
    * @param [String] group id from your database
    * @param [Object] payload to be send
    * @param [Object] options for the request
    *
    * @return [Promise] response from the server
    */

  }, {
    key: 'setGroup',
    value: function setGroup(groupId) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!_config2.default.enabled) return true;

      return _group2.default.update(groupId, (0, _deepmerge2.default)(_message2.default.base, payload), requestOptions);
    }

    /*
    * create/update identity
    *
    * @param [String] user id from your database
    * @param [Object] payload to be send
    * @param [Object] options for the request
    *
    * @return [Promise] response from the server
    */

  }, {
    key: 'setIdentity',
    value: function setIdentity(userId) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!_config2.default.enabled) return true;

      return _identity2.default.update(userId, (0, _deepmerge2.default)(_message2.default.base, payload), requestOptions);
    }

    /*
    * create a watcher
    *
    * @param [String|Integer] template flow name or id
    * @param [Object] payload to be send
    * @param [Object] options for the request
    *
    * @return [Promise] response from the server
    */

  }, {
    key: 'watch',
    value: function watch(templateFlow) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (!_config2.default.enabled) return true;

      var payloadToSend = (0, _deepmerge2.default)(_message2.default.base, (0, _deepmerge2.default)(payload, { templateFlow: templateFlow }));

      if (payloadToSend.withoutSession) delete payloadToSend.sessionTrackerId;

      return _watcher2.default.create(payloadToSend, requestOptions);
    }
  }]);

  return LiveQA;
}();

module.exports = LiveQA;